package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.airplane_ticket;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "AIRPLANE_TICKET".
*/
public class airplane_ticketDao extends AbstractDao<airplane_ticket, Long> {

    public static final String TABLENAME = "AIRPLANE_TICKET";

    /**
     * Properties of entity airplane_ticket.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property City_first_id = new Property(1, String.class, "city_first_id", false, "CITY_FIRST_ID");
        public final static Property City_destination_id = new Property(2, String.class, "city_destination_id", false, "CITY_DESTINATION_ID");
        public final static Property Business = new Property(3, String.class, "business", false, "BUSINESS");
        public final static Property Economy = new Property(4, String.class, "economy", false, "ECONOMY");
        public final static Property Created_at = new Property(5, String.class, "created_at", false, "CREATED_AT");
        public final static Property Updated_at = new Property(6, String.class, "updated_at", false, "UPDATED_AT");
    };


    public airplane_ticketDao(DaoConfig config) {
        super(config);
    }
    
    public airplane_ticketDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"AIRPLANE_TICKET\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"CITY_FIRST_ID\" TEXT," + // 1: city_first_id
                "\"CITY_DESTINATION_ID\" TEXT," + // 2: city_destination_id
                "\"BUSINESS\" TEXT," + // 3: business
                "\"ECONOMY\" TEXT," + // 4: economy
                "\"CREATED_AT\" TEXT," + // 5: created_at
                "\"UPDATED_AT\" TEXT);"); // 6: updated_at
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"AIRPLANE_TICKET\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, airplane_ticket entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String city_first_id = entity.getCity_first_id();
        if (city_first_id != null) {
            stmt.bindString(2, city_first_id);
        }
 
        String city_destination_id = entity.getCity_destination_id();
        if (city_destination_id != null) {
            stmt.bindString(3, city_destination_id);
        }
 
        String business = entity.getBusiness();
        if (business != null) {
            stmt.bindString(4, business);
        }
 
        String economy = entity.getEconomy();
        if (economy != null) {
            stmt.bindString(5, economy);
        }
 
        String created_at = entity.getCreated_at();
        if (created_at != null) {
            stmt.bindString(6, created_at);
        }
 
        String updated_at = entity.getUpdated_at();
        if (updated_at != null) {
            stmt.bindString(7, updated_at);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public airplane_ticket readEntity(Cursor cursor, int offset) {
        airplane_ticket entity = new airplane_ticket( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // city_first_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // city_destination_id
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // business
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // economy
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // created_at
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6) // updated_at
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, airplane_ticket entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setCity_first_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setCity_destination_id(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setBusiness(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setEconomy(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setCreated_at(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setUpdated_at(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(airplane_ticket entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(airplane_ticket entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
